<template>
  <div class="col mh-auto w-100 content">
    <p>
      <template v-if="msg">
        {{ msg }}
      </template>
      <template v-else>
        You should have received an email with a confirmation link, if that
        isn't the case click the button below to resend it.
      </template>
    </p>

    <AsyncButton :fn="resend" class="primary">
      Resend email
    </AsyncButton>
  </div>
</template>

<script>
import AsyncButton from '@/components/AsyncButton.vue';
import axios from 'axios';
import Vue from 'vue';

export default {
  data: () => ({
    msg: null,
    validating: false,
  }),
  methods: {
    async resend () {
      this.msg = 'Requesting verification email...';

      try {
        let { data } = await axios.post('/api/auth/send_verification', {
          email: this.$store.state.user.email,
        });

        if (data.verified) {
          Vue.set(this.$store.state.user, 'verified', true);
          this.$router.push('/').catch(() => {});
        }
        else {
          this.msg = 'Verification email sent!';
        }
      }
      catch (e) {
        console.log(e);
        this.msg = null;
      }
    },
    async validate (token) {
      this.validating = true;

      try {
        let { data } = await axios.post('/api/auth/verify', { token });

        console.log(data);
      }
      catch (e) {
        this.msg = null;
        console.log(e.response ? e.response.data.error : e);
      }
    },
  },
  components: {
    AsyncButton,
  },
  mounted () {
    if (!this.$store.state.user) {
      return this.$router.push('/login').catch(() => {});
    }
    else if (this.$store.state.user.verified) {
      return this.$router.push('/').catch(() => {});
    }
    if (this.$route.query.tok) {
      this.validate(this.$route.query.tok);
    }
  },
};
</script>

<style scoped>
.content {
  max-width: 500px;
}
</style>
